/*
 * Z_SPI.c
 *
 * Created: 10/11/2021 1:00:07 PM
 *  Author: Zedan
 */ 

#include <avr/io.h>
//#define F_CPU 8000000UL
//#define  F_CPU 14745600UL
//7#include <util/delay.h>
#include "Z_SPI.h"

void SPI_MasterInit(void)
{
	DDRB  =(1<<SS) | (1<<MOSI) | (1<<SCK);  // Set SS, MOSI, SCK  as output pins for SPI master. Defined in Z_SPI.h	
	PORTB|=(1<<SS);  //set SS to high - means no slave selected - if this moved below, will not work
	
	//Enable SPI master-  SPI Mode 0
	SPCR=~(1<<CPOL) & ~(1<<CPHA);  //Enable SPI Mode 0
	SPCR=(1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPR1); //Enable SPI as Master, clock to Fosc/128, Enable SPI interrupt
	//SPCR=(1<<SPE)|(1<<MSTR); //Enable SPI as Master, clock to Fosc/4, Enable SPI interrupt
	
	//Enable SPI master-  SPI Mode 3
	//SPCR=(1<<CPOL)|(1<<CPHA);  //Enable SPI Mode 3
	//SPCR=(1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPR1); //Enable SPI Mode 3, Master, clock to Fosc/128, Enable SPI interrupt
		
	SPSR &= ~(1<<SPI2X); // Disable speed doubler	
}


uint8_t SPI_SndByte(uint8_t Data)
{
	//char flush_buffer;
	SPDR=Data; //Load data to Data Register
	while(!(SPSR & (1<<SPIF)));	//Wait till transmission complete (as long as SPIF=0)
	//while ( !(SPSR & _BV(SPIF)) );
	//flush_buffer = SPDR;
	return SPDR;
}

uint8_t SPI_RcvByte()
{
	SPDR=0xFF; //Load dummy data to Data Register
	while(!(SPSR & (1<<SPIF)));	//Wait till transmission complete (as long as SPIF=0)
	//while ( !(SPSR & _BV(SPIF)) );
	return SPDR;  //Read received data
}


void SPI_SndData(int *ptr)
{ 
	while((*ptr)!=0)
	{
		SPI_SndByte(*ptr);
		ptr++;
	}
}

void  SPI_RecData(char *buf, uint16_t len)  
{
	//This function reads number of bytes and store it into buf
	for (uint16_t var = 0; var < len; var++) {
		buf[var] = SPI_RcvByte();
		//*buf=SPI_RcvByte();
		//*buf++;
	}
	//return buf;   //Change return type to char* if you uncomment
}