/*
 * Z_SPI.h
 *
 * Created: 10/11/2021 12:58:19 PM
 *  Author: Zedan
 */ 

#include <avr/io.h>

#ifndef Z_SPI_H_
#define Z_SPI_H_

/* Define SPI bus pins */
#define MOSI		PINB5								
#define MISO		PINB6
#define SCK			PINB7
#define SS			PINB4
#define SS_Enable	PORTB&= ~(1<<SS)				// SPI Slave Select 
#define SS_Disable	PORTB|= (1<<SS)					// SPI Slave De-Select 

#define W5500_CS    PINB4								// PB4 Output as CS (Salve Select) for Wiznet ETHERNET
#define W5500_Select()		PORTB&= ~(1<<W5500_CS)	// W5500 Slave Select
#define W5500_DeSelect()	PORTB|= (1<<W5500_CS)	// W5500 Slave De-Select

/* Prototype SPI function */

void SPI_MasterInit(void);					//Initialize MCU as SPI Master
uint8_t SPI_SndByte(uint8_t Data);			//Send one Byte through SPI
uint8_t SPI_RcvByte();						//Receive one Byte through SPI
void SPI_SndData(int *ptr);					//Send Stream of bytes (stored in a pointer to integers)
void SPI_RecData(char *buf, uint16_t len);  //Receive a defined number of bytes

#endif /* Z_SPI_H_ */